

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.Writer;
import java.io.PrintWriter;
import java.io.StringWriter;

public class Editor  {

		public int interacting=1;
		public String message;
		public JFileChooser fc;
		
		class EditDialog extends JDialog implements ActionListener {
				public double [][][][] target;

				public void actionPerformed(ActionEvent e) {
						String command=e.getActionCommand();
						if (command.startsWith("F"))  // Fade interface 
								fadeWithMessage(command.substring(1));
				}
				public void fadeWithMessage(String message_) {
						setEnabledRecursive(false);
						interacting=0;
						message=message_;
				}

				public JButton fadeButton(String text,String message) {
						JButton fade=new JButton(text);
						fade.addActionListener(this);
						fade.setActionCommand("F"+message);
						return fade;
				}

				public JTextField [][] maskInput;
				public JTextField [][] denomInput;

				EditDialog(double [][][][] mask) {
						super((Frame)null,"Mask Editor",false);
						addWindowListener(new WindowAdapter() {
										public void windowClosing(WindowEvent ev) {
												ActionEvent e=new ActionEvent(this,0,"Fcancel");
												actionPerformed(e);
										}
								});
						maskInput=new JTextField[2][2];
						denomInput=new JTextField[2][2];
						target=mask;
						GridBagConstraints gbc=new GridBagConstraints();
						gbc.gridheight=1;
						gbc.weightx=0;
						gbc.weighty=0;
						gbc.gridwidth=GridBagConstraints.REMAINDER;
						gbc.fill=GridBagConstraints.BOTH;

						getContentPane().setLayout(new GridBagLayout());
						if (mask.length!=0) {
								if (mask[0][0].length!=2||mask[0][0][0].length!=2) {
										JOptionPane.showMessageDialog
												(null,
												 "Mask is not in right format",
												 "Error while preparing Mask editor",
												 JOptionPane.ERROR_MESSAGE);
								}
						}

						boolean skipx=true;

						//						System.out.println(""+mask.length);
						if (mask[0].length!=1)
								skipx&=false;

						for (int i=0;i<4;i++) {
								int k=i%2;
								int l=i/2;
								String edit="";
								for (int y=0;y<mask.length;y++) {
										for (int x=0;x<mask[y].length;x++)
												if (skipx)
														edit=edit+" "+y+" "+mask[y][x][k][l]+"  ;  ";
												else
														edit=edit+y+" "+x+" "+mask[y][x][k][l]+"  ;  ";
								}
								JLabel jla=new JLabel("A("+k+","+l+")");
								maskInput[k][l]=new JTextField(edit);

								gbc.gridheight=1;
								gbc.weightx=0.001;
								gbc.weighty=1;
								gbc.gridwidth=1;
								gbc.fill=GridBagConstraints.BOTH;
								jla.setLabelFor(maskInput[k][l]);
								
								gbc.gridwidth=4;
								getContentPane().add(jla,gbc);
								gbc.weightx=1;
								getContentPane().add
										(new JScrollPane
										 (maskInput[k][l],
											JScrollPane.VERTICAL_SCROLLBAR_NEVER,
											JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS
											),gbc);

								gbc.weightx=0;
								gbc.gridwidth=1;
								gbc.fill=GridBagConstraints.BOTH;

								getContentPane().add(new JLabel("  *  "),gbc);

								JPanel jp=new JPanel();
								GridBagConstraints gbc2=new GridBagConstraints();
								jp.setLayout(new GridBagLayout());
								gbc2.gridwidth=GridBagConstraints.REMAINDER;
								gbc2.gridheight=5;
								gbc2.fill=GridBagConstraints.HORIZONTAL;

								gbc2.weightx=1;
								gbc2.weighty=1;
								JLabel one=new JLabel("  1  ");
								one.setHorizontalAlignment(SwingConstants.CENTER);
								jp.add(one,gbc2);

								gbc2.gridheight=1;
								jp.add(new Line(),gbc2);

								gbc2.gridheight=5;
								denomInput[k][l]=new JTextField(6);
								jp.add(denomInput[k][l],gbc2);
								gbc.gridwidth=GridBagConstraints.REMAINDER;
								gbc.fill=GridBagConstraints.BOTH;
								getContentPane().add(jp,gbc);
								gbc.gridheight=2;
								gbc.gridwidth=GridBagConstraints.REMAINDER;
								getContentPane().add(new JPanel(),gbc);
						}
						JPanel jp=new JPanel();
						jp.setLayout(new GridLayout(1,3));
						jp.add(fadeButton("OK","ok"));
						JButton jb=new JButton("Save");
						jb.addActionListener(new ActionListener() {
										public void actionPerformed(ActionEvent e) {
												int returnVal=fc.showOpenDialog(null);
												if (returnVal==JFileChooser.APPROVE_OPTION) {
														fadeWithMessage("Save "+fc.getSelectedFile());
												}
										}});
						jp.add(jb);
						jp.add(fadeButton("Cancel","cancel"));

						getContentPane().add(jp,gbc);

						pack();
						setSize(700,500);

				}
				public void setEnabledRecursiveOnContainer
						(Container cont,boolean enabled) {
						Component [] components = cont.getComponents();
						for(int i=0; i<components.length; i++) {
								((Component)components[i]).setEnabled(enabled);								
								if(components[i] instanceof Container) {
										setEnabledRecursiveOnContainer((Container)components[i],enabled);
								} 
								
						}
				}
				public void setEnabledRecursive(boolean enabled) {
						setEnabledRecursiveOnContainer(getContentPane(),enabled);
				}

		}

		EditDialog frame;

		public void edit(double [][][][] mask,JFileChooser fc) {
				this.fc=fc;
				if (mask==null)
						mask=new double [][][][] {};
				frame=new EditDialog(mask);
				frame.setVisible(true);
		}
		
		public static Vector parse(String s) {

				Vector semisplit=new Vector();
				String accu="";
				for (int i=0;i<s.length();i++) {
						switch (s.charAt(i)) {
						case ';':
								semisplit.add(accu);
								accu="";
								break;
						default:
								accu=accu+s.charAt(i);
								break;
						}
				}

				semisplit.add(accu);

				Vector spacesplit;
				Vector results=new Vector();

				String t;
				int maxl=0;
				for (int i=0;i<semisplit.size();i++) {
						spacesplit=new Vector();
						t=(String)semisplit.elementAt(i);
						accu="";
						for (int j=0;j<t.length();j++) {
								switch (t.charAt(j)) {
								case ' ':
										if (!accu.equals(""))
												spacesplit.add(accu);
										accu="";
										break;
								default:
										accu+=""+t.charAt(j);
										break;
								}
						}
						if (!accu.equals(""))
								spacesplit.add(accu);
						if (spacesplit.size()>maxl)
								maxl=spacesplit.size();
						results.add(spacesplit);
				}
				
				return results;
		}
		

		public void interact() {
				interacting=1;
				message="If you can read this, something is broken.";
				frame.setEnabledRecursive(true);
		}

		public double [][][][] getMask() {
				int xmax=0,ymax=0;
				int xmin=0,ymin=0;
				int i=0,j=0;
				int dims=0;
				try {
						int x=0,y=0;
						for (i=0;i<2;i++)
								for (j=0;j<2;j++) {
										Vector parse=parse(frame.maskInput[i][j].getText());
										for (int k=0;k<parse.size();k++) {
												if (dims==0)
														dims=((Vector)parse.elementAt(k)).size();
												else {
														if (((Vector)parse.elementAt(k)).size()==0)
																continue; // empty element -?
														if (((Vector)parse.elementAt(k)).size()!=dims)
																throw new Exception("Dimension Mismatch in A("+i+","+j+"), element "+(k+1));
												}
												try {
														x=Integer.parseInt((String)((Vector)parse.elementAt(k)).elementAt(0));
														y=Integer.parseInt((String)((Vector)parse.elementAt(k)).elementAt(1));
												} catch (NumberFormatException e) {
														// Ignore silently
												}
												if (x>xmax)
														xmax=x;
												if (y>ymax)
														ymax=y;
												if (x<xmin)
														xmin=x;
												if (y<ymin)
														ymin=y;
												
										}
								}

						if (dims==2)
								ymax=ymin=0;

						double [][][][] tmp=new double [2][2][xmax-ymin+1][ymax-ymin+1];
				
						boolean usedenom=true;
						double denom[][]=new double [2][2];

						for (i=0;i<2;i++)
								for (j=0;j<2;j++) {
										try {
												denom[i][j]=Double.parseDouble(frame.denomInput[i][j].getText());
												usedenom=usedenom&true;
										} catch (Exception e) {
												usedenom=false;
												denom[i][j]=0; // will break if used
										}
								}

						if (usedenom)
								mwa.output("Denominators Applied");
						else
								mwa.output("Denominators Ignored");

						for (i=0;i<2;i++)
								for (j=0;j<2;j++) {
										Vector parse=parse(frame.maskInput[i][j].getText());
										//										System.out.println(parse);
										double d;
										Vector subparse;
										tmp[i][j]=new double[xmax+1][ymax+1];
										for (int k=0;k<parse.size();k++) {
												subparse=(Vector)parse.elementAt(k);
												if (subparse.size()==0)
														continue; // empty element is ignored
												switch (dims) {
												case 2:
														x=Integer.parseInt((String)subparse.elementAt(0));
														y=0;
														d=Double.parseDouble((String)subparse.elementAt(1));
														break;
												case 3:
														x=Integer.parseInt((String)subparse.elementAt(0));
														y=Integer.parseInt((String)subparse.elementAt(1));
														d=Double.parseDouble((String)subparse.elementAt(2));
														break;
												default:
														mwa.output("Illegal dimension "+dims+" in Editor.java");
														return null;
												}
												if (usedenom)
														tmp[i][j][x][y]=d/denom[i][j];
												else
														tmp[i][j][x][y]=d;
										}
								}
						return tmp;
				} catch (Exception e) {
						JOptionPane.showMessageDialog(null, e.toString(), "Input error", JOptionPane.ERROR_MESSAGE);
						return null;
				}

		}


		public void endedit() throws Exception {
				frame.setVisible(false);
				frame=null;
		}

		MultiWaveletAssistant mwa;
		public Editor(MultiWaveletAssistant mwa) {
				this.mwa=mwa;
		}

		/*		public static void main(String [] argv) {
				try {
						String [][] bla=Editor.parse("0 0 0; 1 1 223 ; 2 2 2  ;  3   3   3   ;  4 4 4");
						System.out.println(bla[1][2]);
				} catch (Exception e) {
						e.printStackTrace();
				}
				}*/

}
		
