function sro=sumrules(mask,M)
  d=size(M,1);
  r=size(mask,1);
  R=representatives(M);
  m=size(R,2);
  [sbm,beta]=submasks(M,mask,R);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
  % sum rules of order 1
  JA_0=JA(M,zeros(d,1),R(:,1),sbm{1},beta{1});
  [V,D]=eig(JA_0);
  ev1=find(abs(diag(D)-1)<sqrt(eps));
  ev1=V(:,ev1);
  err=zeros(size(ev1));
  for i=2:m
    ja=JA(M,zeros(d,1),R(:,i),sbm{i},beta{i});
    err=err+abs(ja*ev1-ev1);
    JA_0=cat(3,JA_0,ja);
  end
  err=find(sum(err,1)<10*sqrt(eps));
  if prod(size(err))==0
    err=1;
  else
    y_0=ev1(:,err(1));
    err=0;
  end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
  % sum rules of higher order as a linear equation system
  sro=0;JA_nu={};nu=[];y_nu=[];
  while err==0
    sro=sro+1;
    mu=multiind(sro,d);
    % building the right hand side of the sum rules of order sro 
    rhs=[];
    for i=1:size(mu,2)
      mui=mu(:,i);
      if prod(size(nu))>0
	idx=(nu-kron(mui,ones(1,size(nu,2))))<=0;
	idx=prod(double(idx),1);
	idx=find(idx==1);
      else
	idx=[];
      end
      ja=[];rhsi=[];
      for k=1:m
	ja=cat(3,ja,JA(M,mui,R(:,k),sbm{k},beta{k}));
	rhsik=(-1)^sum(mui,1)*ja(:,:,k)*y_0;
	for j=1:size(idx,2)
	  mu_nu=mui-nu(:,idx(j));
	  idx2=find(sum(abs(nu-kron(mu_nu,ones(1,size(nu,2)))),1)==0);
	  rhsik=rhsik+(-1)^sum(mu_nu,1)*JA_nu{idx2}(:,:,k)*y_nu(:,idx(j));
	end
	rhsi=[rhsi,rhsik];
      end
      JA_nu=cat(2,JA_nu,{ja});
      rhs=[rhs;rhsi];
    end
    % left hand sides are more simple, but we have to choose the "most invertible" lhs
    lhs=kron(matrix_munu_nonsymb(M,mu),eye(r));
    condlhs=[];
    for i=1:m
      condlhs=[condlhs,cond(lhs-kron(eye(size(mu,2)),JA_0(:,:,i)))];
    end
    ii=find(condlhs==min(condlhs));
    lhs0=lhs-kron(eye(size(mu,2)),JA_0(:,:,ii(1)));
    % now, we can compute y_mu
    y_mu=lhs0\rhs(:,ii(1));
    err=sum(isinf(y_mu)+isnan(y_mu));
    if err>0
      err=1;
    else
      % checking all sum rules of order sro
      err=[];
      for i=1:m
	lhs0=lhs-kron(eye(size(mu,2)),JA_0(:,:,i));
	err=[err;norm(lhs0*y_mu-rhs(:,i))];
      end
      if sum(err)>10*sqrt(eps)
	err=1;
      else
	err=0;
	nu=[nu,mu];
	y_mu=reshape(y_mu,r,size(mu,2));
	y_nu=[y_nu,y_mu];
      end
    end
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function ja=JA(M,nu,rho,sbm_rho,beta_rho)
  r=size(sbm_rho,1);
  N=size(beta_rho,2);
  ja=reshape(sbm_rho,r^2,N);
  beta2=prod((M\beta_rho).^kron(nu,ones(1,N)),1)/prod(factorial(nu),1);
  ja=sum(ja.*kron(ones(r^2,1),beta2),2);
  ja=reshape(ja,r,r)';
end

function Mmunu=matrix_munu_nonsymb(M,mu)
% mu= vector of all multiindices with |mu|=m
  sz=size(mu,2);
  Mmunu=zeros(sz);
  for i=1:sz
    for j=1:sz
      Mmunu(i,j)=munu(M,mu(:,i),mu(:,j));
    end
  end
end

function mn=munu(M,mu,nu)
  d=size(nu,1);
  alph=cell(1,d);
  for i=1:d
    alph{i}=multiind(nu(i),d);
  end
  sums=cell(size(alph{1},2),2);
  for i=1:size(alph{1},2)
    sums{i,1}=alph{1}(:,i);
    sums{i,2}=alph{1}(:,i);
  end
  for i=2:d
    sums0={};
    alphi=alph{i};
    for j=1:size(alphi,2)
      alpha=alphi(:,j);
      for k=1:size(sums,1)
	beta=alpha+sums{k,1};
	if prod(double(beta<=mu),1)>0
	  sums0=cat(1,sums0,{beta,[sums{k,2},alpha]});
	end
      end
    end
    clear sums;
    sums=sums0;
  end
  iM=inv(M);
  mn=0;
  for i=1:size(sums,1)
    alpha=sums{i,2};
    mn=mn+prod(factorial(nu),1)/prod(prod(factorial(alpha),2),1)*prod(prod(iM.^alpha,2),1);
  end
end
  
function Mmunu=matrix_munu(M,mu)
% simple but slow version that uses Symbolic Math Toolbox
  x=[];
  for i=1:size(M,1)
    x=[x;sym(['x',num2str(i)])];
  end
  x=M\x;
  Mmu=kron(x,sym(ones(1,size(mu,2)))).^mu;
  Mmu=prod(Mmu,1)./prod(factorial(mu),1);
  Mmunu=[];
  for i=1:size(mu,2)
    Mmunui=Mmu;
    for j=1:size(mu,1)
      Mmunui=diff(Mmunui,['x',num2str(j)],mu(j,i));
    end
    Mmunu=[Mmunu;double(Mmunui)];
  end
  Mmunu=Mmunu';
end

function  [sbm,beta]=submasks(M,mask,R);
  d=size(M,1);
  r=size(mask,1);
  N=(size(mask,2)/r)^(1/d);
  if ceil(N)-floor(N)>0
    disp('inadmissible mask: dimensions do not fit!');
    sbm={};
    beta={};
    return;
  end
  sbm=cell(size(R,2),1);
  beta=cell(size(R,2),1);
  allbeta=all_s2m(N,1,[1:N^d],d);
  for i=1:size(R,2)
    idx=M\(allbeta-kron(ones(1,size(allbeta,2)),R(:,i)));
    idx=sum(ceil(idx)-floor(idx),1);
    idx=find(idx==0);
    beta{i}=allbeta(:,idx);
    idx=kron(idx,r*ones(1,r))-kron(ones(1,size(idx,2)),[r-1:-1:0]);
    sbm{i}=mask(:,idx);
  end
end

function mu=multiind(k,d)
  % computes all d-dimesional multiindices mu with |mu|=k  
  if d==1
    mu=k;
  elseif k==0
    mu=zeros(d,1);
  else
    mu=[];
    for i=0:k
      mui=multiind(i,d-1);
      mui=[(k-i)*ones(1,size(mui,2));mui];
      mu=[mu,mui];
    end
  end
end

function R=representatives(M)
  % computes complete set of representatives of Z^d/MZ^d
  m=abs(det(M));
  cube=[];
  for i=1:m
    cube=[cube,multiind(i,size(M,1))];
  end
  R=zeros(size(M,1),1);
  for i=1:m-1
    cube2=M\(cube-kron(R(:,i),ones(1,size(cube,2))));
    cube2=sum(ceil(cube2)-floor(cube2),1);
    cube=cube(:,find(cube2>0));
    R=[R,cube(:,1)];
  end
end

function alphak=all_s2m(maxidx,idx0,k,d)
  % maps vector of single indices k to multiindices alpha of dimension d via lexicographical order
  % alpha is in a d-dimensional cube with sidelength maxidx and lower left corner 
  % (-idx0+1,...,-idx0+1)
  maxv=maxidx*ones(size(k));
  k0=k-1;
  dif=zeros(d,size(k,2));
  for j=0:d-1
    dif(d-j,:)=mod(k0,maxidx);
    k0=(k0-dif(d-j,:))./maxidx;
  end
  alphak0=kron(ones(1,size(k,2)),(-idx0+1)*ones(d,1));
  alphak=alphak0+dif;
end
