
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;

public class MaskTable extends JPanel implements ActionListener {

		static float norm(Double [][] m) {
				double acc=0;
				for (int i=0;i<m.length;i++)
						for (int j=0;j<m.length;j++)
								acc += m[j][i].doubleValue()*m[j][i].doubleValue();
				return (float)acc;
		}
		
		public void actionPerformed(ActionEvent e) {
				System.out.println(e.getActionCommand());
		}

		public JPanel makeMatrix(Double [][] m,int xoff,int yoff) {
				JPanel jp=new JPanel();
				int w=m.length;
				int h=m[0].length;

				jp.setLayout(new GridLayout(h,w));

				for (int i=0;i<h;i++)
						for (int j=0;j<w;j++) {
								double v=m[i][j].doubleValue();
								double norm=v*v;
								norm=Math.log(norm);
								norm/=10;
								norm+=1;
								//								System.out.println(norm);
								if (norm<0)
										norm=0;
								if (norm>1)
										norm=1;

								norm*=Math.PI/2;
								
								JButton jb=new JButton(new Double(v).toString());
								jb.setBackground(new Color((float)Math.abs(Math.sin(norm)),
																					 (float)Math.abs(Math.sin(norm+Math.PI/3)),
																					 (float)Math.abs(Math.sin(norm+Math.PI/3*2))));
								jb.setActionCommand((xoff+j)+";"+(yoff+i));
								jb.addActionListener(this);
								jp.add(jb);
						}
				jp.setBorder(BorderFactory.createEmptyBorder(3,3,3,3));
				return jp;
		}

		public MaskTable(Double [][][][] content) {
				super();
				
				int w=content.length;
				int h=content[0].length;

				setLayout(new GridLayout(h,w));

				for (int i=0;i<h;i++)
						for (int j=0;j<w;j++) {
								JPanel jp=makeMatrix(content[i][j],2*j,2*i);
								add(jp);
						}
		}

		
		public static void main(String [] test) {
				Double [][][][]data=
						{{{{new Double(1),new Double(0.0187654)},
							 {new Double(0.5),new Double(0.001)}},
							{{new Double(0.25),new Double(0.00187654)},
							 {new Double(0.125),new Double(0.001)}}},
						 {{{new Double(0.0625),new Double(0.0187654)},
							 {new Double(0.0375),new Double(1)}},
							{{new Double(1),new Double(0.0000001)},
							 {new Double(1),new Double(0.001)}}}};
				MaskTable mt=new MaskTable(data);
				JFrame jf=new JFrame("Test");
				jf.getContentPane().add(mt);
				jf.setVisible(true);
		}
}
