
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.net.*;

public class MultiWaveletAssistant {

		public int [][] dilMat;

		public PlotOptions plotOptions;

		public int interacting=1;
		public String message;
		public int [][] sumRuleOrder;


		public JFileChooser fc;

    public class MainFrame extends JFrame implements ActionListener {
				JTextArea output;
				GridBagConstraints gbc;


				public MultiWaveletAssistant ui;

				public JButton fadeButton(String text,String message) {
						JButton fade=new JButton(text);
						fade.addActionListener(this);
						fade.setActionCommand("F"+message);
						return fade;
				}


				// Generate dilatation matritx edit pane
				final JTabbedPane tabbedPane=new JTabbedPane();

				public Component makeMatrixInput() {

						JPanel panel1d=new JPanel();

						JTextField entry1d=new JTextField("2",3);

						final int dilMat1d[][]={{2}};
						JLabel label1d=new JLabel("M=");
						label1d.setLabelFor(entry1d);
						panel1d.add(label1d);
						panel1d.add(entry1d);
						new IntegerArrayModifier(dilMat1d,1,1,entry1d);

						JPanel panel2d=new JPanel();

						final int dilMat2d[][]={{1,-1},{1,1}};
						JPanel matrix2d=new JPanel();
						matrix2d.setLayout(new GridLayout(2,2));
						for (int i=0;i<2;i++) 
								for (int j=0;j<2;j++) {
										JTextField xin=new JTextField
												(new Integer(dilMat2d[i][j]).toString(),3);
										new IntegerArrayModifier(dilMat2d,i,j,xin);
										matrix2d.add(xin);
								}


						JLabel label2d=new JLabel("M=");
						label2d.setLabelFor(matrix2d);
						panel2d.add(label2d);
						panel2d.add(matrix2d);

						tabbedPane.addTab("1-Dimensional",panel1d);
						tabbedPane.addTab("2-Dimensional",panel2d);
						//						tabbedPane.setMnemonicAt(0,KeyEvent.VK_1);
						//						tabbedPane.setMnemonicAt(1,'2');//KeyEvent.VK_2);
						tabbedPane.addChangeListener(new ChangeListener() {
										public void stateChanged(ChangeEvent e) {
												switch (tabbedPane.getSelectedIndex()) {
												case 0:
														dilMat=dilMat1d;
														break;
												case 1:
														dilMat=dilMat2d;
														break;
												}
										}
								});
						dilMat=dilMat1d;
						return tabbedPane;
				}

				JTextField srentry;

				public JComponent makeSumruleInput() {
						JPanel sumrule=new JPanel(); 
						srentry=new JTextField("5",3);
						JLabel srlabel=new JLabel("sum rule order");
						JButton srestimate=fadeButton("Estimate","estimate");

						srlabel.setLabelFor(srentry);
						sumrule.add(srlabel);
						sumrule.add(srentry);
						sumrule.add(srestimate);
						sumRuleOrder = new int [1][1];
						sumRuleOrder[0][0]=5;
						new IntegerArrayModifier(sumRuleOrder,0,0,srentry);
						
						return sumrule;
				}

				public void setSumRule(int i) {
						srentry.setText(""+i);
						sumRuleOrder[0][0]=i;
				}


				public JDialog makeplotoptionsdialog(final String message,
																						 boolean wavelet) {

						JButton ok,cancel;
						GridBagConstraints gbc=new GridBagConstraints();

						final JDialog po=new JDialog(this,"Plot Options",false);
						po.getContentPane().setLayout(new GridBagLayout());

						gbc.gridwidth=GridBagConstraints.REMAINDER;
						gbc.gridheight=1;
						gbc.weightx=6;
						po.getContentPane().add(new JPanel(),gbc); // Fix Layout issues
						gbc.weightx=1;
						gbc.weighty=1;						
						gbc.fill=GridBagConstraints.BOTH;
						Component plotpars;
						plotpars=new PlotParPanel(this,plotOptions);

						po.getContentPane().add(plotpars,gbc);
						ok=new JButton("OK");
						ok.setMnemonic(KeyEvent.VK_O);
						cancel=new JButton("Cancel");
						cancel.setMnemonic(KeyEvent.VK_C);
						cancel.addActionListener(new ActionListener() {
										public void actionPerformed(ActionEvent e) {
												po.setVisible(false);
										}});
						ok.addActionListener(new ActionListener() {
										public void actionPerformed(ActionEvent e) {
												po.setVisible(false);
												fadeWithMessage(message);
										}});
						
						if (wavelet) {

								// Additional Wavelet Buttons

								JButton load,edit,def;
								
								load=new JButton("Load Wavelet Mask");
								edit=fadeButton("Edit Wavelet Mask","EditW");
								def=fadeButton("Default Wavelet","DefW");

								load.addActionListener(new ActionListener() {
												public void actionPerformed(ActionEvent e) {
														if (fc==null)
																fc=new JFileChooser();
														fc.addChoosableFileFilter(new MatFilter());
														int returnVal=fc.showOpenDialog(null);
														if (returnVal==JFileChooser.APPROVE_OPTION) {
																fadeWithMessage("LoadW "+fc.getSelectedFile());
														}
												}
										});
								load.setMnemonic(KeyEvent.VK_W);
								edit.setMnemonic(KeyEvent.VK_E);
								def.setMnemonic(KeyEvent.VK_D);

								gbc.gridwidth=2;
								po.getContentPane().add(load,gbc);
								po.getContentPane().add(def,gbc);
								gbc.gridwidth=GridBagConstraints.REMAINDER;
								po.getContentPane().add(edit,gbc);

						} 
						gbc.gridwidth=3;
						po.getContentPane().add(ok,gbc);
						gbc.gridwidth=GridBagConstraints.REMAINDER;
						po.getContentPane().add(cancel,gbc);
						po.pack();
						int height=150;
						
						if (dilMat.length==2) 
								height+=120;
						if (wavelet)
								height+=50;

						po.setSize(450,height);
						
						return po;
				}

				public MainFrame(MultiWaveletAssistant ui) {
						super ();

						URL imageURL = getClass().getClassLoader().
								getResource("splash.png");

						if (imageURL!=null)
								setIconImage(new ImageIcon(imageURL).getImage());

						setTitle("Multiwavelet assistant");
						addWindowListener(new WindowAdapter() {
										public void windowClosing(WindowEvent ev) {
												ActionEvent e=new ActionEvent(this,0,"Fquit");
												actionPerformed(e);
										}
								});
						

						this.ui=ui;
						// Intercept closing events

						addWindowListener(new WindowAdapter() {
										public void windowClosing(WindowEvent e) {
												interacting=0;
										}});
						
						getContentPane().setLayout(new BorderLayout());						


						// Northern panel: Load, Edit, Dilatation Matrix input, SRO

						JPanel north=new JPanel();

						BoxLayout bl=new BoxLayout(north,BoxLayout.X_AXIS);
						north.setLayout(bl);

						JPanel nbuttons=new JPanel();
						nbuttons.setLayout(new GridLayout(2,1));

						JButton loadMask=new JButton("Load Scaling Mask");
						loadMask.addActionListener(new ActionListener() {
										public void actionPerformed(ActionEvent e) {
												if (fc==null)
														fc=new JFileChooser();
												fc.addChoosableFileFilter(new MatFilter());
												int returnVal=fc.showOpenDialog(null);
												if (returnVal==JFileChooser.APPROVE_OPTION) {
														fadeWithMessage("LoadS "+fc.getSelectedFile());
												}
										}
								});
						loadMask.setMnemonic(KeyEvent.VK_L);
						nbuttons.add(loadMask);


						JButton editMask=fadeButton("Edit Scaling Mask","EditS");
						nbuttons.add(editMask);
						editMask.setMnemonic(KeyEvent.VK_E);
						north.add(nbuttons);


						// North East Pane: Dilatation Matrix, SRO
						JPanel nepane=new JPanel();
						bl=new BoxLayout(nepane,BoxLayout.Y_AXIS);
						nepane.setLayout(bl);

						JComponent sri=makeSumruleInput();
						
						nepane.add(makeMatrixInput());
						nepane.add(Box.createVerticalGlue());

						nepane.add(sri);

						north.add(nepane);
						
						getContentPane().add(north,BorderLayout.NORTH);

 


						// East panel: Load and Edit Mask

						//						getContentPane().add(ebuttons,BorderLayout.EAST);

						
						// South Panel: Plot and Regularity


						JPanel south=new JPanel();
						south.setLayout(new GridLayout(1,2));

						JPanel plots=new JPanel();
						plots.setLayout(new GridLayout(2,1));

						JButton splotbutton=new JButton ("Plot Generator");
					  plots.add(splotbutton);
						splotbutton.setMnemonic(KeyEvent.VK_G);
						splotbutton.addActionListener(new ActionListener() {
										public void actionPerformed(ActionEvent e) {
												JDialog splotoptionsd;
												splotoptionsd=makeplotoptionsdialog("plots",false);
												splotoptionsd.setVisible(true);
												//												splotoptionsd.finalize();
										}});

						JButton wplotbutton=new JButton ("Plot Wavelet");
						wplotbutton.setMnemonic(KeyEvent.VK_W);
					  plots.add(wplotbutton);
						wplotbutton.addActionListener(new ActionListener() {
										public void actionPerformed(ActionEvent e) {
												JDialog wplotoptionsd;
												wplotoptionsd=makeplotoptionsdialog("plotw",true);
												wplotoptionsd.setVisible(true);
												//												wplotoptionsd.finalize();
										}});

						south.add(plots);
						JButton regbutton=fadeButton("Estimate Regularity","Regularity");
						regbutton.setMnemonic(KeyEvent.VK_R);
						south.add(regbutton);
						getContentPane().add(south,BorderLayout.SOUTH);						


						output=new JTextArea("");
						output.setEditable(false);
						JScrollPane fbsp=new JScrollPane(output);
						getContentPane().add(fbsp); // default: CENTER
						
						pack();
						setSize(600,400);
				}
				public void output(String message) {
						output.append(message+"\n");
						output.setCaretPosition(output.getText().length()); // Fix scrolling issue

				}
				public void fadeWithMessage(String message) {
						setEnabledRecursive(false);
						interacting=0;
						ui.message=message;
				}
				public void actionPerformed(ActionEvent e) {
						String command=e.getActionCommand();
						if (command.startsWith("F"))  // Fade interface 
								fadeWithMessage(command.substring(1));
				}

				public void setEnabledRecursiveOnContainer(Container cont,boolean enabled) {
						Component [] components = cont.getComponents();
						for(int i=0; i<components.length; i++) {
								((Component)components[i]).setEnabled(enabled);

								if(components[i] instanceof Container) {
										setEnabledRecursiveOnContainer((Container)components[i],enabled);
								} 
								
						}
				}
				public void setD(int i) {
						tabbedPane.setSelectedIndex(i-1);
				}
				public void setEnabledRecursive(boolean enabled) {
						setEnabledRecursiveOnContainer(getContentPane(),enabled);
				}
    }
		MainFrame frame;
    public MultiWaveletAssistant() {
				plotOptions=new PlotOptions();
				int [][] corners={{-1,6},{-4,4}};
				plotOptions.corners=corners;
				int [][] offset={{0,0}};
				plotOptions.offset=offset;
				int [][] iterations={{4}};
				plotOptions.iterations=iterations;
				plotOptions.automatic=true;
				int [][] contours={{15}};
				plotOptions.contours=contours;
				plotOptions.contour=true;
				frame=new MainFrame(this);
				frame.setVisible(true);
				new SplashWindow(frame); 
    }
		public void output(String s) {
				frame.output(s);
		}
		public void setSumRule(int i) {
				frame.setSumRule(i);
		}

		public void setD(int i) {
				frame.setD(i);
		}
		public void interact() {
				interacting=1;
				message="If you can read this, something is broken.";
				frame.setEnabledRecursive(true);
		}
		public static void main(String a[]) {
				MultiWaveletAssistant test=new MultiWaveletAssistant();
		}
}

